package com.hzya.frame.plugin.a8bill.service.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.map.MapBuilder;
import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.ningboBankTreasury.dto.res.AccTransactionRes;
import com.hzya.frame.ningboBankTreasury.enums.CurrencyEnum;
import com.hzya.frame.plugin.a8bill.service.INingboBankPluginService;
import com.hzya.frame.seeyon.dongj.entity.Formmain0044Entity;
import com.hzya.frame.seeyon.dongj.service.IFormmain0044Service;
import com.hzya.frame.stringutil.StringUtil;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Description 宁波银行插件用
 * @Author xiangerlin
 * @Date 2024/7/25 16:34
 **/
public class NingboBankPluginServiceImpl implements INingboBankPluginService {

@Autowired
private IFormmain0044Service formmain0044Service;
    Logger logger = LoggerFactory.getLogger(getClass());
    @Value("${OA.data_source_code}")
    private String oa_data_source_code;

    /**
     * 调用宁波银行esb接口
     *
     * @param params
     * @param apiCode
     * @return
     */
    @Override
    public String executeEsb(String params, String apiCode) {
        logger.info("请求apiCode:{},参数:{}",apiCode,params);
        Map<String, String> header =  MapBuilder.<String, String>create(true)
                .put("apiCode", apiCode)
                .put("publicKey","ZJYAWb7lhAUTYqekPkU+uHJv1/ObJxb7dT7sD8HPRDGAgyhCe7eDIk+3zDUT+v578prj")
                .put("secretKey","fviZnLBsQUAGF8w8FSOdJi7XlIm/XAZclMxRagDLfTyJFlvnIBF3w66Hrpfzs8cYj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=")
                .put("appId","800036")
                .build();
        String res = HttpRequest.post("http://127.0.0.1:9999/kangarooDataCenterV3/entranceController/externalCallInterface").addHeaders(header).body(params).timeout(60000).execute().body();
        return res;
    }

    /**
     * 保存收款日志到oa底表
     * @param accTransactionResList
     */
    @Override
    public void saveAccLog(List<AccTransactionRes> accTransactionResList) {
        if (CollectionUtils.isNotEmpty(accTransactionResList)){
            //查询已经存在的数据
            Formmain0044Entity formmain0044 = new Formmain0044Entity();
            formmain0044.setStart_date(DateUtil.lastWeek().toDateStr());
            formmain0044.setDataSourceCode(oa_data_source_code);
            List<Formmain0044Entity> formmain0044List = formmain0044Service.querySeridId(formmain0044);
            //过滤已保存的数据
            if (CollectionUtils.isNotEmpty(formmain0044List) && CollectionUtils.isNotEmpty(accTransactionResList)){
                accTransactionResList = accTransactionResList.stream()
                        .filter(acc -> formmain0044List.stream()
                                .noneMatch(f -> acc.getSerialId().equals(f.getField0018())))
                        .collect(Collectors.toList());
            }
            if (CollectionUtils.isNotEmpty(accTransactionResList)){
                for (AccTransactionRes accTransactionRes : accTransactionResList) {
                    String bankAcc = StringUtil.nullConvert(accTransactionRes.getBankAcc());
                    String bankName = StringUtil.nullConvert(accTransactionRes.getBankName());
                    String accName = StringUtil.nullConvert(accTransactionRes.getAccName());
                    String oppAccNo = StringUtil.nullConvert(accTransactionRes.getOppAccNo());
                    String oppAccName = StringUtil.nullConvert(accTransactionRes.getOppAccName());
                    String oppAccBank = StringUtil.nullConvert(accTransactionRes.getOppAccBank());
                    String transTime = StringUtil.nullConvert(accTransactionRes.getTransTime());
                    //这个是唯一的
                    String serialId = StringUtil.nullConvert(StringUtil.replaceBlank(accTransactionRes.getSerialId()));
                    String amt = StringUtil.nullConvert(accTransactionRes.getAmt());
                    String abs = StringUtil.nullConvert(accTransactionRes.getAbs());
                    String bankType = StringUtil.nullConvert(accTransactionRes.getBankType());
                    String serialNo = StringUtil.nullConvert(accTransactionRes.getSerialNo());
                    String currency = StringUtil.nullConvert(CurrencyEnum.getNameByCode(accTransactionRes.getCurCode()));
                    String uses = StringUtil.nullConvert(accTransactionRes.getUses());
                    //String curCode = StringUtil.nullConvert(accTransactionRes.getCurCode());
                    //这里转换成货币符号
                    String curCode = StringUtil.nullConvert(CurrencyEnum.getSymbolByCode(accTransactionRes.getCurCode()));
                    String postScript = StringUtil.nullConvert(accTransactionRes.getPostScript());
                    String data = StrUtil.format(getAccLogXmlTemplate(),bankAcc,bankName,accName,oppAccNo,oppAccName,oppAccBank,transTime,serialId,amt,abs,bankType,serialNo,currency,uses,postScript,curCode);
                    JSONObject paramsTemplate = new JSONObject();
                    paramsTemplate.put("loginName", "oa1");
                    paramsTemplate.put("dataXml", data);
                    Map<String, String> header =  MapBuilder.<String, String>create(true)
                            .put("apiCode", "8000340006")
                            .put("publicKey","ZJYAA9Z/jWMe1rC+Sjh8NVMRtwVMb5Bn0DbmIEsgpVlR3C9Ce7eDIk+3zDUT+v578prj")
                            .put("secretKey","B8sgQwEaskwM7BQj1XLvu3kdKD3xm7Lyd4FWsPaFQk5v+UtQLCkzVzLlCZ9Bdyv2j3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=")
                            .put("appId","800034")
                            .build();
                    String res = HttpRequest.post("http://127.0.0.1:9999/kangarooDataCenterV3/entranceController/externalCallInterface").addHeaders(header).body(paramsTemplate.toString()).timeout(60000).execute().body();
                    System.out.println("保存oa底表结果:"+res);
                }
            }
        }
    }


    private static String getAccLogXmlTemplate(){
      //  return "<forms  version=\"2.1\"><formExport><summary  id=\"1828182906863371818\" name=\"formmain_0044\"/><definitions><column  id=\"field0001\" type=\"0\" name=\"我方账号\" isNullable=\"false\" length=\"200\"/><column  id=\"field0017\" type=\"0\" name=\"我方开户行\" isNullable=\"false\" length=\"200\"/><column  id=\"field0024\" type=\"0\" name=\"我方户名\" isNullable=\"false\" length=\"200\"/><column  id=\"field0029\" type=\"0\" name=\"客户方账号\" isNullable=\"false\" length=\"200\"/><column  id=\"field0022\" type=\"0\" name=\"客户方户名\" isNullable=\"false\" length=\"2000\"/><column  id=\"field0030\" type=\"0\" name=\"客户方开户行\" isNullable=\"false\" length=\"500\"/><column  id=\"field0018\" type=\"2\" name=\"交易日期\" isNullable=\"false\" length=\"255\"/><column  id=\"field0019\" type=\"0\" name=\"交易流水号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0020\" type=\"4\" name=\"收款金额\" isNullable=\"false\" length=\"20\"/><column  id=\"field0021\" type=\"0\" name=\"摘要\" isNullable=\"false\" length=\"500\"/><column  id=\"field0025\" type=\"0\" name=\"银行类型\" isNullable=\"false\" length=\"100\"/><column  id=\"field0026\" type=\"0\" name=\"银行流水号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0027\" type=\"0\" name=\"币种\" isNullable=\"false\" length=\"100\"/><column  id=\"field0028\" type=\"0\" name=\"用途\" isNullable=\"false\" length=\"800\"/><column  id=\"field0031\" type=\"0\" name=\"关联客户号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0032\" type=\"0\" name=\"客商编号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0033\" type=\"0\" name=\"交易代码\" isNullable=\"false\" length=\"100\"/><column  id=\"field0034\" type=\"0\" name=\"客商名称\" isNullable=\"false\" length=\"100\"/><column  id=\"field0035\" type=\"0\" name=\"对账码\" isNullable=\"false\" length=\"100\"/><column  id=\"field0036\" type=\"0\" name=\"备注\" isNullable=\"false\" length=\"800\"/><column  id=\"field0037\" type=\"0\" name=\"ERP业务参考号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0038\" type=\"0\" name=\"币种ID\" isNullable=\"false\" length=\"100\"/><column  id=\"field0039\" type=\"0\" name=\"币种编码\" isNullable=\"false\" length=\"100\"/><column  id=\"field0040\" type=\"0\" name=\"控制只关联1次\" isNullable=\"false\" length=\"100\"/><column  id=\"field0044\" type=\"4\" name=\"收款剩余金额\" isNullable=\"false\" length=\"20\"/><column  id=\"field0045\" type=\"0\" name=\"收款完成情况\" isNullable=\"false\" length=\"100\"/><column  id=\"field0046\" type=\"4\" name=\"是否收款完成\" isNullable=\"false\" length=\"20\"/></definitions><values><column  name=\"我方账号\"><value><![CDATA[{}]]></value></column><column  name=\"我方开户行\"><value><![CDATA[{}]]></value></column><column  name=\"我方户名\"><value><![CDATA[{}]]></value></column><column  name=\"客户方账号\"><value><![CDATA[{}]]></value></column><column  name=\"客户方户名\"><value><![CDATA[{}]]></value></column><column  name=\"客户方开户行\"><value><![CDATA[{}]]></value></column><column  name=\"交易日期\"><value><![CDATA[{}]]></value></column><column  name=\"交易流水号\"><value><![CDATA[{}]]></value></column><column  name=\"收款金额\"><value><![CDATA[{}]]></value></column><column  name=\"摘要\"><value><![CDATA[{}]]></value></column><column  name=\"银行类型\"><value><![CDATA[{}]]></value></column><column  name=\"银行流水号\"><value><![CDATA[{}]]></value></column><column  name=\"币种\"><value><![CDATA[{}]]></value></column><column  name=\"用途\"><value><![CDATA[{}]]></value></column><column  name=\"关联客户号\"><value><![CDATA[{}]]></value></column><column  name=\"客商编号\"><value><![CDATA[{}]]></value></column><column  name=\"交易代码\"><value><![CDATA[{}]]></value></column><column  name=\"客商名称\"><value><![CDATA[{}]]></value></column><column  name=\"对账码\"><value><![CDATA[{}]]></value></column><column  name=\"备注\"><value><![CDATA[{}]]></value></column><column  name=\"ERP业务参考号\"><value><![CDATA[{}]]></value></column><column  name=\"币种ID\"><value><![CDATA[{}]]></value></column><column  name=\"币种编码\"><value><![CDATA[{}]]></value></column><column  name=\"控制只关联1次\"><value><![CDATA[{}]]></value></column><column  name=\"收款剩余金额\"><value><![CDATA[{}]]></value></column><column  name=\"收款完成情况\"><value><![CDATA[{}]]></value></column><column  name=\"是否收款完成\"><value><![CDATA[{}]]></value></column></values><subForms/></formExport></forms>";
        return "<forms  version=\"2.1\"><formExport><summary  id=\"1828182906863371818\" name=\"formmain_0044\"/><definitions><column  id=\"field0001\" type=\"0\" name=\"我方账号\" isNullable=\"false\" length=\"200\"/><column  id=\"field0017\" type=\"0\" name=\"我方开户行\" isNullable=\"false\" length=\"200\"/><column  id=\"field0024\" type=\"0\" name=\"我方户名\" isNullable=\"false\" length=\"200\"/><column  id=\"field0029\" type=\"0\" name=\"客户方账号\" isNullable=\"false\" length=\"200\"/><column  id=\"field0022\" type=\"0\" name=\"客户方户名\" isNullable=\"false\" length=\"2000\"/><column  id=\"field0030\" type=\"0\" name=\"客户方开户行\" isNullable=\"false\" length=\"500\"/><column  id=\"field0018\" type=\"2\" name=\"交易日期\" isNullable=\"false\" length=\"255\"/><column  id=\"field0019\" type=\"0\" name=\"交易流水号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0020\" type=\"4\" name=\"收款金额\" isNullable=\"false\" length=\"20\"/><column  id=\"field0021\" type=\"0\" name=\"摘要\" isNullable=\"false\" length=\"500\"/><column  id=\"field0025\" type=\"0\" name=\"银行类型\" isNullable=\"false\" length=\"100\"/><column  id=\"field0026\" type=\"0\" name=\"银行流水号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0027\" type=\"0\" name=\"币种\" isNullable=\"false\" length=\"100\"/><column  id=\"field0028\" type=\"0\" name=\"用途\" isNullable=\"false\" length=\"800\"/><column  id=\"field0036\" type=\"0\" name=\"备注\" isNullable=\"false\" length=\"800\"/><column  id=\"field0039\" type=\"0\" name=\"币种编码\" isNullable=\"false\" length=\"100\"/></definitions><values><column  name=\"我方账号\"><value><![CDATA[{}]]></value></column><column  name=\"我方开户行\"><value><![CDATA[{}]]></value></column><column  name=\"我方户名\"><value><![CDATA[{}]]></value></column><column  name=\"客户方账号\"><value><![CDATA[{}]]></value></column><column  name=\"客户方户名\"><value><![CDATA[{}]]></value></column><column  name=\"客户方开户行\"><value><![CDATA[{}]]></value></column><column  name=\"交易日期\"><value><![CDATA[{}]]></value></column><column  name=\"交易流水号\"><value><![CDATA[{}]]></value></column><column  name=\"收款金额\"><value><![CDATA[{}]]></value></column><column  name=\"摘要\"><value><![CDATA[{}]]></value></column><column  name=\"银行类型\"><value><![CDATA[{}]]></value></column><column  name=\"银行流水号\"><value><![CDATA[{}]]></value></column><column  name=\"币种\"><value><![CDATA[{}]]></value></column><column  name=\"用途\"><value><![CDATA[{}]]></value></column><column  name=\"备注\"><value><![CDATA[{}]]></value></column><column  name=\"币种编码\"><value><![CDATA[{}]]></value></column></values><subForms/></formExport></forms>";
    }
}
